--[[
Description: This plugin is part of the "Titan Panel [Professions] Multi" addon. It shows your Blacksmithing skill level.
Site: http://www.curse.com/addons/wow/titan-panel-professions-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "BLAM"
local BLAM, prevBLAM = 0.0, -2
local BLAMmax, preBLAMmax = 0, 0
local startskill
-----------------------------------------------
local function OnClick(self, button)
	if (button == "LeftButton") then
		local prof = L["blacksmithing"]
		CastSpellByName(prof)
	end
end
-----------------------------------------------
local function OnUpdate(self, id)
	local prof1, prof2 = GetProfessions();
	local skillLevel = 0
	local maxSkillLevel = 0

	if prof1 then
		local name, _, level, maxLevel = GetProfessionInfo(prof1)
		if name == L["blacksmithing"] then
			skillLevel = level
			maxSkillLevel = maxLevel
		elseif prof2 then
			name, _, level, maxLevel = GetProfessionInfo(prof2)
			if name == L["blacksmithing"] then
				skillLevel = level
				maxSkillLevel = maxLevel
			end
		end
	end

	BLAM = skillLevel
	BLAMmax = maxSkillLevel
	if not startskill then startskill = skillLevel end

	if BLAM == prevBLAM and BLAMmax == preBLAMmax then
		return
	end

	preBLAMmax = BLAMmax
	prevBLAM = BLAM

	TitanPanelButton_UpdateButton(id)
	return true
end
-----------------------------------------------
local function GetButtonText(self, id)
	local BLAMtext
	local HideText = "" -- Texto HideMax
	if not TitanGetVar(ID, "HideMax") then
		HideText = "|r/|cFFFF2e2e"..BLAMmax
	end

	local BarBalanceText = ""
	if BLAMmax ~= 0 and (BLAM - startskill) > 0 and TitanGetVar(ID, "ShowBarBalance") then
		BarBalanceText = " |cFF69FF69["..(BLAM - startskill).."]"
	end

	if BLAM == 700 then
		BLAMtext = "|cFF69FF69"..L["maximum"]
	elseif BLAMmax == 0 then
		BLAMtext = "|cFFFF2e2e"..L["noprof"]
	elseif BLAM == BLAMmax then
		BLAMtext = "|cFFB4EEB4"..L["gotrainer"]
	else
		BLAMtext = "|cFFFFFFFF"..BLAM..HideText..BarBalanceText
	end

	return L["blacksmithing"]..": ", BLAMtext
end
-----------------------------------------------
local function GetTooltipText(self, id)
	local ColorValueAccount -- Cores da conta de valor
	if not BLAM then
		ColorValueAccount = ""
	elseif BLAM == 700 then
		ColorValueAccount = ""
	elseif (BLAM - startskill) == 0 then
		ColorValueAccount = "\r"..L["session"]..TitanUtils_GetHighlightText("0")
	elseif (BLAM - startskill) > 0 then
		ColorValueAccount = "\r"..L["session"].."|cFF69FF69"..(BLAM - startskill)
	end

	local ValueText = "" -- Difere com e sem profissão
	if BLAM == 0 then
		ValueText = L["noskill"]
	else
		ValueText = L["tooltipDescription"]..L["blacksmithing"].."."..ColorValueAccount
	end

	return ValueText
end
-----------------------------------------------
L.Elib({
	id = ID,
	name = "Titan|cFFccce00 "..L["blacksmithing"].."|r".." Multi",
	tooltip = L["blacksmithing"],
	icon = "Interface\\Icons\\Trade_blacksmithing.blp",
	category = "Profession",
	version = version,
	onUpdate = OnUpdate,
	onClick = OnClick,
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	prepareMenu = L.PrepareProfessionsMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		HideMax = false,
		ShowBarBalance = false,
		ShowLabelText = false,
	}
})
