--[[
Description: This plugin is part of the "Titan Panel [Professions] Multi" addon. It shows your First Aid skill level.
Site: http://www.curse.com/addons/wow/titan-panel-professions-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "FIRM"
local FIRM, prevFIRM = 0.0, -2
local FIRMmax, prevFIRMmax = 0, 0
local startskill
-----------------------------------------------
local function OnClick(self, button)
	if (button == "LeftButton") then
		local prof = L["firstAid"]
		CastSpellByName(prof)
	end
end
-----------------------------------------------
local function OnUpdate(self, id)
	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();

	if firstAid ~= nil then
		local name, _, skillLevel, maxSkillLevel, _, _, _, _ = GetProfessionInfo(firstAid)
		FIRM = skillLevel
		FIRMmax = maxSkillLevel
		if not startskill then startskill = skillLevel end

		if FIRM == prevFIRM and prevFIRMmax == FIRMmax then
			return
		end

		prevFIRMmax = FIRMmax
		prevFIRM  = FIRM

		TitanPanelButton_UpdateButton(id)
		return true
	end
end
-----------------------------------------------
local function GetButtonText(self, id)
	local FIRMtext
	local HideText = "" -- Texto HideMax
	if not TitanGetVar(ID, "HideMax") then
		HideText = "|r/|cFFFF2e2e"..FIRMmax
	end

	local BarBalanceText = ""
	if FIRMmax ~= 0 and (FIRM - startskill) > 0 and TitanGetVar(ID, "ShowBarBalance") then
		BarBalanceText = " |cFF69FF69["..(FIRM - startskill).."]"
	end

	if FIRM == 700 then
		FIRMtext = "|cFF69FF69"..L["maximum"]
	elseif FIRMmax == 0 then
		FIRMtext = "|cFFFF2e2e"..L["noprof"]
	elseif FIRM == FIRMmax then
		FIRMtext = "|cFFB4EEB4"..L["gotrainer"]
	else
		FIRMtext = "|cFFFFFFFF"..FIRM..HideText..BarBalanceText
	end

	return L["firstAid"]..": ", FIRMtext
end
-----------------------------------------------
local function GetTooltipText(self, id)
	local ColorValueAccount -- Cores da conta de valor
	if FIRMmax == 0 then
		ColorValueAccount = ""
	elseif FIRM == 700 then
		ColorValueAccount = ""
	elseif (FIRM - startskill) == 0 then
		ColorValueAccount = "\r"..L["session"]..TitanUtils_GetHighlightText("0")
	elseif (FIRM - startskill) > 0 then
		ColorValueAccount = "\r"..L["session"].."|cFF69FF69"..(FIRM - startskill)
	end

	local ValueText = "" -- Difere com e sem profissão
	if FIRM == 0 then
		ValueText = L["nosecskill"]
	else
		ValueText = L["tooltipDescription"]..L["firstAid"].."."..ColorValueAccount
	end

	return ValueText
end
-----------------------------------------------
L.Elib({
	id = ID,
	name = "Titan|cFF05a7ab "..L["firstAid"].."|r".." Multi",
	tooltip = L["firstAid"],
	icon = "Interface\\Icons\\Spell_holy_sealofsacrifice.blp",
	category = "Profession",
	version = version,
	onUpdate = OnUpdate,
	onClick = OnClick,
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	prepareMenu = L.PrepareProfessionsMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		HideMax = false,
		ShowBarBalance = false,
		ShowLabelText = false,
	}
})
